// PouzitiDatabazeView.cpp : implementation of the CPouzitiDatabazeView class
//

#include "stdafx.h"
#include "PouzitiDatabaze.h"

#include "PouzitiDatabazeSet.h"
#include "PouzitiDatabazeDoc.h"
#include "PouzitiDatabazeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPouzitiDatabazeView

IMPLEMENT_DYNCREATE(CPouzitiDatabazeView, CRecordView)

BEGIN_MESSAGE_MAP(CPouzitiDatabazeView, CRecordView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRecordView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRecordView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CPouzitiDatabazeView construction/destruction

CPouzitiDatabazeView::CPouzitiDatabazeView()
	: CRecordView(CPouzitiDatabazeView::IDD)
{
	m_pSet = NULL;
	// TODO: add construction code here

}

CPouzitiDatabazeView::~CPouzitiDatabazeView()
{
}

void CPouzitiDatabazeView::DoDataExchange(CDataExchange* pDX)
{
	CRecordView::DoDataExchange(pDX);
	// you can insert DDX_Field* functions here to 'connect' your controls to the database fields, ex.
	DDX_FieldText(pDX, IDC_ID, m_pSet->m_id, m_pSet);
	DDX_FieldText(pDX, IDC_NAZEV, m_pSet->m_nazev, m_pSet);
	DDX_FieldText(pDX, IDC_POCET, m_pSet->m_pocet, m_pSet);
	// DDX_FieldCheck(pDX, IDC_MYCHECKBOX, m_pSet->m_bColumn2, m_pSet);
	// See MSDN and ODBC samples for more information
}

BOOL CPouzitiDatabazeView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CRecordView::PreCreateWindow(cs);
}

void CPouzitiDatabazeView::OnInitialUpdate()
{
	m_pSet = &GetDocument()->m_PouzitiDatabazeSet;
	CRecordView::OnInitialUpdate();
}


// CPouzitiDatabazeView printing

BOOL CPouzitiDatabazeView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CPouzitiDatabazeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CPouzitiDatabazeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CPouzitiDatabazeView::OnDraw(CDC *pDC)
{
	CPoint actText(0, 0);

	// chceme vypsat vsechno v databazi...
	// nesmime hnout s pozici (kurzorem) ukazujici na aktualni zaznam v databazi, aby dobre
	// fungovala editacni policka, ta na aktualni zaznam spolehaji

	// jedeme s kurzorem na zacatek databaze a v promenne i si zapamatovavame, kolikrat
	// jsme se posunuli, abychom se pak vratili
	int i = 0;
	while (!m_pSet->IsBOF())
	{
		i++;
		m_pSet->MovePrev();
	}

	if (i==0)
		return; // prazdna sada zaznamu, neni co vypisovat

	// posunem se na prvni a vypisujeme vsechno
	m_pSet->MoveFirst();
	while (!m_pSet->IsEOF())
	{
		// id a pocet jsou typu long, abychom je vypsali, potrebujeme retezec, pouzijeme
		// metodu Format tridy CString, ktera umi nacist do retezce temer cokoliv,
		// typy parametru se specifikuji jako u printf()
		CString id;
		id.Format("%d", m_pSet->m_id);
		CString pocet;
		pocet.Format("%d", m_pSet->m_pocet);

		pDC->TextOut(actText.x, actText.y, id);
		pDC->TextOut(actText.x + 100, actText.y, m_pSet->m_nazev); // m_nazev je CString, neni treba nejak konvertovat
		pDC->TextOut(actText.x + 300, actText.y, pocet);
		m_pSet->MoveNext();
		actText.y += 20;
	}

	// posuneme se opet na zacatek a hybneme se tolikrat dopredu, kolik jsme si
	// napocitali, abychom kurzor dali na tu pozici, kde byl kdyz se zavolala nase metoda
	m_pSet->MoveFirst();
	while (i > 1)
	{
		m_pSet->MoveNext();
		i--;
	}

}

// CPouzitiDatabazeView diagnostics

#ifdef _DEBUG
void CPouzitiDatabazeView::AssertValid() const
{
	CRecordView::AssertValid();
}

void CPouzitiDatabazeView::Dump(CDumpContext& dc) const
{
	CRecordView::Dump(dc);
}

CPouzitiDatabazeDoc* CPouzitiDatabazeView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPouzitiDatabazeDoc)));
	return (CPouzitiDatabazeDoc*)m_pDocument;
}
#endif //_DEBUG


// CPouzitiDatabazeView database support
CRecordset* CPouzitiDatabazeView::OnGetRecordset()
{
	return m_pSet;
}



// CPouzitiDatabazeView message handlers
